Graphics3D 800,600,32,2
SetBuffer BackBuffer()

pxCreateWorld(1,"")

cam = CreateCamera()
PositionEntity cam,0,10,-20

plane = CreatePlane()
EntityColor plane,64,128,128

light = CreateLight()

Global TableMesh = CreateCube()
ScaleMesh TableMesh,3,0.3,1.5
PositionMesh TableMesh,0,3.3,0
leg = CreateCapsule(1.5,0.5)
PositionMesh leg,0,1.5,0
AddMesh leg, TableMesh
FreeEntity leg
sph = CreateSphere()
ScaleMesh sph,2,2,2
PositionMesh sph,0,-0.5,0
AddMesh sph, TableMesh
FreeEntity sph
HideEntity TableMesh

Desc = pxCreateCompoundDesc()
Sh = pxCompoundAddCubeShape(Desc,3,0.3,1.5)
pxCompoundSetShapePos(Sh,0,3.3,0)
Sh = pxCompoundAddCapsuleShape(Desc,0.5,1.5)
pxCompoundSetShapePos(Sh,0,1.5,0)
Sh = pxCompoundAddSphereShape(Desc,2)
pxCompoundSetShapePos(Sh,0,-0.5,0)


Global TableBody = pxCreateCompound(Desc,1)
pxBodySetFlagCollision TableBody,0


Repeat

If KeyHit(57) Then CreatepxTable(0,10,0)

pxRenderPhysic(60,0)
UpdatepxTables()

RenderWorld()
Flip

Until KeyHit(1)
End

Type pxTable
	Field mesh
	Field body
End Type

Function UpdatepxTables()
	For pxT.pxTable = Each pxTable
		pxBodySetEntity pxT\mesh, pxT\body
	Next
End Function

Function CreatepxTable(x#,y#,z#)
	pxT.pxTable = New pxTable
	pxT\mesh = CopyEntity(TableMesh)
	pxT\body = pxCopyBody(TableBody)	
	pxBodySetPosition pxT\body,x+Rnd(-10,10),y,z+Rnd(-2,2)
	pxBodySetRotation pxT\body,Rnd(-100,100),Rnd(-100,100),Rnd(-100,100)
End Function

Function CreateCapsule(height#,radius# )
    cyl = CreateCylinder()
    ScaleMesh cyl, radius, height-radius*0.5, radius
    
    sph = CreateSphere()
    ScaleMesh sph, radius,radius,radius
    PositionMesh sph, 0,height-radius*0.5,0
    AddMesh sph, cyl
    
    PositionMesh sph, 0,-height*2+radius,0
    AddMesh sph, cyl

    FreeEntity sph
    Return cyl
End Function